<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>ContentType xref</title>
<link type="text/css" rel="stylesheet" href="../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../apidocs/org/apache/http/entity/ContentType.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.entity;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.io.Serializable;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.nio.charset.Charset;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.nio.charset.UnsupportedCharsetException;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.util.Locale;
<a class="jxr_linenumber" name="34" href="#34">34</a>  
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.Consts;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.Header;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HeaderElement;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntity;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.NameValuePair;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.ParseException;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.Immutable;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.message.BasicHeaderValueParser;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.Args;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.TextUtils;
<a class="jxr_linenumber" name="45" href="#45">45</a>  
<a class="jxr_linenumber" name="46" href="#46">46</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="47" href="#47">47</a>  <em class="jxr_javadoccomment"> * Content type information consisting of a MIME type and an optional charset.</em>
<a class="jxr_linenumber" name="48" href="#48">48</a>  <em class="jxr_javadoccomment"> * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="49" href="#49">49</a>  <em class="jxr_javadoccomment"> * This class makes no attempts to verify validity of the MIME type.</em>
<a class="jxr_linenumber" name="50" href="#50">50</a>  <em class="jxr_javadoccomment"> * The input parameters of the {@link #create(String, String)} method, however, may not</em>
<a class="jxr_linenumber" name="51" href="#51">51</a>  <em class="jxr_javadoccomment"> * contain characters &lt;"&gt;, &lt;;&gt;, &lt;,&gt; reserved by the HTTP specification.</em>
<a class="jxr_linenumber" name="52" href="#52">52</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="53" href="#53">53</a>  <em class="jxr_javadoccomment"> * @since 4.2</em>
<a class="jxr_linenumber" name="54" href="#54">54</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="55" href="#55">55</a>  @Immutable
<a class="jxr_linenumber" name="56" href="#56">56</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> <strong class="jxr_keyword">implements</strong> Serializable {
<a class="jxr_linenumber" name="57" href="#57">57</a>  
<a class="jxr_linenumber" name="58" href="#58">58</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">long</strong> serialVersionUID = -7768694718232371896L;
<a class="jxr_linenumber" name="59" href="#59">59</a>      
<a class="jxr_linenumber" name="60" href="#60">60</a>      <em class="jxr_comment">// constants</em>
<a class="jxr_linenumber" name="61" href="#61">61</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> APPLICATION_ATOM_XML = create(
<a class="jxr_linenumber" name="62" href="#62">62</a>              <span class="jxr_string">"application/atom+xml"</span>, Consts.ISO_8859_1);
<a class="jxr_linenumber" name="63" href="#63">63</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> APPLICATION_FORM_URLENCODED = create(
<a class="jxr_linenumber" name="64" href="#64">64</a>              <span class="jxr_string">"application/x-www-form-urlencoded"</span>, Consts.ISO_8859_1);
<a class="jxr_linenumber" name="65" href="#65">65</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> APPLICATION_JSON = create(
<a class="jxr_linenumber" name="66" href="#66">66</a>              <span class="jxr_string">"application/json"</span>, Consts.UTF_8);
<a class="jxr_linenumber" name="67" href="#67">67</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> APPLICATION_OCTET_STREAM = create(
<a class="jxr_linenumber" name="68" href="#68">68</a>              <span class="jxr_string">"application/octet-stream"</span>, (Charset) <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="69" href="#69">69</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> APPLICATION_SVG_XML = create(
<a class="jxr_linenumber" name="70" href="#70">70</a>              <span class="jxr_string">"application/svg+xml"</span>, Consts.ISO_8859_1);
<a class="jxr_linenumber" name="71" href="#71">71</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> APPLICATION_XHTML_XML = create(
<a class="jxr_linenumber" name="72" href="#72">72</a>              <span class="jxr_string">"application/xhtml+xml"</span>, Consts.ISO_8859_1);
<a class="jxr_linenumber" name="73" href="#73">73</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> APPLICATION_XML = create(
<a class="jxr_linenumber" name="74" href="#74">74</a>              <span class="jxr_string">"application/xml"</span>, Consts.ISO_8859_1);
<a class="jxr_linenumber" name="75" href="#75">75</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> MULTIPART_FORM_DATA = create(
<a class="jxr_linenumber" name="76" href="#76">76</a>              <span class="jxr_string">"multipart/form-data"</span>, Consts.ISO_8859_1);
<a class="jxr_linenumber" name="77" href="#77">77</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> TEXT_HTML = create(
<a class="jxr_linenumber" name="78" href="#78">78</a>              <span class="jxr_string">"text/html"</span>, Consts.ISO_8859_1);
<a class="jxr_linenumber" name="79" href="#79">79</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> TEXT_PLAIN = create(
<a class="jxr_linenumber" name="80" href="#80">80</a>              <span class="jxr_string">"text/plain"</span>, Consts.ISO_8859_1);
<a class="jxr_linenumber" name="81" href="#81">81</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> TEXT_XML = create(
<a class="jxr_linenumber" name="82" href="#82">82</a>              <span class="jxr_string">"text/xml"</span>, Consts.ISO_8859_1);
<a class="jxr_linenumber" name="83" href="#83">83</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> WILDCARD = create(
<a class="jxr_linenumber" name="84" href="#84">84</a>              <span class="jxr_string">"*/*"</span>, (Charset) <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="85" href="#85">85</a>  
<a class="jxr_linenumber" name="86" href="#86">86</a>      <em class="jxr_comment">// defaults</em>
<a class="jxr_linenumber" name="87" href="#87">87</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> DEFAULT_TEXT = TEXT_PLAIN;
<a class="jxr_linenumber" name="88" href="#88">88</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> DEFAULT_BINARY = APPLICATION_OCTET_STREAM;
<a class="jxr_linenumber" name="89" href="#89">89</a>  
<a class="jxr_linenumber" name="90" href="#90">90</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> String mimeType;
<a class="jxr_linenumber" name="91" href="#91">91</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> Charset charset;
<a class="jxr_linenumber" name="92" href="#92">92</a>  
<a class="jxr_linenumber" name="93" href="#93">93</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="94" href="#94">94</a>  <em class="jxr_javadoccomment">     * Given a MIME type and a character set, constructs a ContentType.</em>
<a class="jxr_linenumber" name="95" href="#95">95</a>  <em class="jxr_javadoccomment">     * @param mimeType The MIME type to use for the ContentType header.</em>
<a class="jxr_linenumber" name="96" href="#96">96</a>  <em class="jxr_javadoccomment">     * @param charset The optional character set to use with the ContentType header.</em>
<a class="jxr_linenumber" name="97" href="#97">97</a>  <em class="jxr_javadoccomment">     * @throws  UnsupportedCharsetException</em>
<a class="jxr_linenumber" name="98" href="#98">98</a>  <em class="jxr_javadoccomment">     *          If no support for the named charset is available in this Java virtual machine</em>
<a class="jxr_linenumber" name="99" href="#99">99</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="100" href="#100">100</a>     <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a>(<strong class="jxr_keyword">final</strong> String mimeType, <strong class="jxr_keyword">final</strong> Charset charset) {
<a class="jxr_linenumber" name="101" href="#101">101</a>         <strong class="jxr_keyword">this</strong>.mimeType = mimeType;
<a class="jxr_linenumber" name="102" href="#102">102</a>         <strong class="jxr_keyword">this</strong>.charset = charset;
<a class="jxr_linenumber" name="103" href="#103">103</a>     }
<a class="jxr_linenumber" name="104" href="#104">104</a> 
<a class="jxr_linenumber" name="105" href="#105">105</a>     <strong class="jxr_keyword">public</strong> String getMimeType() {
<a class="jxr_linenumber" name="106" href="#106">106</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.mimeType;
<a class="jxr_linenumber" name="107" href="#107">107</a>     }
<a class="jxr_linenumber" name="108" href="#108">108</a> 
<a class="jxr_linenumber" name="109" href="#109">109</a>     <strong class="jxr_keyword">public</strong> Charset getCharset() {
<a class="jxr_linenumber" name="110" href="#110">110</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.charset;
<a class="jxr_linenumber" name="111" href="#111">111</a>     }
<a class="jxr_linenumber" name="112" href="#112">112</a> 
<a class="jxr_linenumber" name="113" href="#113">113</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="114" href="#114">114</a> <em class="jxr_javadoccomment">     * Converts a ContentType to a string which can be used as a ContentType header.</em>
<a class="jxr_linenumber" name="115" href="#115">115</a> <em class="jxr_javadoccomment">     * If a charset is provided by the ContentType, it will be included in the string.</em>
<a class="jxr_linenumber" name="116" href="#116">116</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="117" href="#117">117</a>     @Override
<a class="jxr_linenumber" name="118" href="#118">118</a>     <strong class="jxr_keyword">public</strong> String toString() {
<a class="jxr_linenumber" name="119" href="#119">119</a>         StringBuilder buf = <strong class="jxr_keyword">new</strong> StringBuilder();
<a class="jxr_linenumber" name="120" href="#120">120</a>         buf.append(<strong class="jxr_keyword">this</strong>.mimeType);
<a class="jxr_linenumber" name="121" href="#121">121</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.charset != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="122" href="#122">122</a>             buf.append(<span class="jxr_string">"; charset="</span>);
<a class="jxr_linenumber" name="123" href="#123">123</a>             buf.append(<strong class="jxr_keyword">this</strong>.charset.name());
<a class="jxr_linenumber" name="124" href="#124">124</a>         }
<a class="jxr_linenumber" name="125" href="#125">125</a>         <strong class="jxr_keyword">return</strong> buf.toString();
<a class="jxr_linenumber" name="126" href="#126">126</a>     }
<a class="jxr_linenumber" name="127" href="#127">127</a> 
<a class="jxr_linenumber" name="128" href="#128">128</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> valid(<strong class="jxr_keyword">final</strong> String s) {
<a class="jxr_linenumber" name="129" href="#129">129</a>         <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; s.length(); i++) {
<a class="jxr_linenumber" name="130" href="#130">130</a>             <strong class="jxr_keyword">char</strong> ch = s.charAt(i);
<a class="jxr_linenumber" name="131" href="#131">131</a>             <strong class="jxr_keyword">if</strong> (ch == '&quot;' || ch == ',' || ch == ';') {
<a class="jxr_linenumber" name="132" href="#132">132</a>                 <strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="133" href="#133">133</a>             }
<a class="jxr_linenumber" name="134" href="#134">134</a>         }
<a class="jxr_linenumber" name="135" href="#135">135</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="136" href="#136">136</a>     }
<a class="jxr_linenumber" name="137" href="#137">137</a> 
<a class="jxr_linenumber" name="138" href="#138">138</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="139" href="#139">139</a> <em class="jxr_javadoccomment">     * Creates a new instance of {@link ContentType}.</em>
<a class="jxr_linenumber" name="140" href="#140">140</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="141" href="#141">141</a> <em class="jxr_javadoccomment">     * @param mimeType MIME type. It may not be &lt;code&gt;null&lt;/code&gt; or empty. It may not contain</em>
<a class="jxr_linenumber" name="142" href="#142">142</a> <em class="jxr_javadoccomment">     *        characters &lt;"&gt;, &lt;;&gt;, &lt;,&gt; reserved by the HTTP specification.</em>
<a class="jxr_linenumber" name="143" href="#143">143</a> <em class="jxr_javadoccomment">     * @param charset charset.</em>
<a class="jxr_linenumber" name="144" href="#144">144</a> <em class="jxr_javadoccomment">     * @return content type</em>
<a class="jxr_linenumber" name="145" href="#145">145</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="146" href="#146">146</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> create(<strong class="jxr_keyword">final</strong> String mimeType, <strong class="jxr_keyword">final</strong> Charset charset) {
<a class="jxr_linenumber" name="147" href="#147">147</a>         String type = Args.notBlank(mimeType, <span class="jxr_string">"MIME type"</span>).toLowerCase(Locale.US);
<a class="jxr_linenumber" name="148" href="#148">148</a>         Args.check(valid(type), <span class="jxr_string">"MIME type may not contain reserved characters"</span>);
<a class="jxr_linenumber" name="149" href="#149">149</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a>(type, charset);
<a class="jxr_linenumber" name="150" href="#150">150</a>     }
<a class="jxr_linenumber" name="151" href="#151">151</a> 
<a class="jxr_linenumber" name="152" href="#152">152</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="153" href="#153">153</a> <em class="jxr_javadoccomment">     * Creates a new instance of {@link ContentType} without a charset.</em>
<a class="jxr_linenumber" name="154" href="#154">154</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="155" href="#155">155</a> <em class="jxr_javadoccomment">     * @param mimeType MIME type. It may not be &lt;code&gt;null&lt;/code&gt; or empty. It may not contain</em>
<a class="jxr_linenumber" name="156" href="#156">156</a> <em class="jxr_javadoccomment">     *        characters &lt;"&gt;, &lt;;&gt;, &lt;,&gt; reserved by the HTTP specification.</em>
<a class="jxr_linenumber" name="157" href="#157">157</a> <em class="jxr_javadoccomment">     * @return content type</em>
<a class="jxr_linenumber" name="158" href="#158">158</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="159" href="#159">159</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> create(<strong class="jxr_keyword">final</strong> String mimeType) {
<a class="jxr_linenumber" name="160" href="#160">160</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a>(mimeType, (Charset) <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="161" href="#161">161</a>     }
<a class="jxr_linenumber" name="162" href="#162">162</a>     
<a class="jxr_linenumber" name="163" href="#163">163</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="164" href="#164">164</a> <em class="jxr_javadoccomment">     * Creates a new instance of {@link ContentType}.</em>
<a class="jxr_linenumber" name="165" href="#165">165</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="166" href="#166">166</a> <em class="jxr_javadoccomment">     * @param mimeType MIME type. It may not be &lt;code&gt;null&lt;/code&gt; or empty. It may not contain</em>
<a class="jxr_linenumber" name="167" href="#167">167</a> <em class="jxr_javadoccomment">     *        characters &lt;"&gt;, &lt;;&gt;, &lt;,&gt; reserved by the HTTP specification.</em>
<a class="jxr_linenumber" name="168" href="#168">168</a> <em class="jxr_javadoccomment">     * @param charset charset. It may not contain characters &lt;"&gt;, &lt;;&gt;, &lt;,&gt; reserved by the HTTP</em>
<a class="jxr_linenumber" name="169" href="#169">169</a> <em class="jxr_javadoccomment">     *        specification. This parameter is optional.</em>
<a class="jxr_linenumber" name="170" href="#170">170</a> <em class="jxr_javadoccomment">     * @return content type</em>
<a class="jxr_linenumber" name="171" href="#171">171</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="172" href="#172">172</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> create(
<a class="jxr_linenumber" name="173" href="#173">173</a>             <strong class="jxr_keyword">final</strong> String mimeType, <strong class="jxr_keyword">final</strong> String charset) <strong class="jxr_keyword">throws</strong> UnsupportedCharsetException {
<a class="jxr_linenumber" name="174" href="#174">174</a>         <strong class="jxr_keyword">return</strong> create(mimeType, !TextUtils.isBlank(charset) ? Charset.forName(charset) : <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="175" href="#175">175</a>     }
<a class="jxr_linenumber" name="176" href="#176">176</a> 
<a class="jxr_linenumber" name="177" href="#177">177</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> create(<strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HeaderElement.html">HeaderElement</a> helem) {
<a class="jxr_linenumber" name="178" href="#178">178</a>         String mimeType = helem.getName();
<a class="jxr_linenumber" name="179" href="#179">179</a>         String charset = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="180" href="#180">180</a>         <a href="../../../../org/apache/http/NameValuePair.html">NameValuePair</a> param = helem.getParameterByName(<span class="jxr_string">"charset"</span>);
<a class="jxr_linenumber" name="181" href="#181">181</a>         <strong class="jxr_keyword">if</strong> (param != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="182" href="#182">182</a>             charset = param.getValue();
<a class="jxr_linenumber" name="183" href="#183">183</a>         }
<a class="jxr_linenumber" name="184" href="#184">184</a>         <strong class="jxr_keyword">return</strong> create(mimeType, charset);
<a class="jxr_linenumber" name="185" href="#185">185</a>     }
<a class="jxr_linenumber" name="186" href="#186">186</a> 
<a class="jxr_linenumber" name="187" href="#187">187</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="188" href="#188">188</a> <em class="jxr_javadoccomment">     * Parses textual representation of &lt;code&gt;Content-Type&lt;/code&gt; value.</em>
<a class="jxr_linenumber" name="189" href="#189">189</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="190" href="#190">190</a> <em class="jxr_javadoccomment">     * @param s text</em>
<a class="jxr_linenumber" name="191" href="#191">191</a> <em class="jxr_javadoccomment">     * @return content type</em>
<a class="jxr_linenumber" name="192" href="#192">192</a> <em class="jxr_javadoccomment">     * @throws ParseException if the given text does not represent a valid</em>
<a class="jxr_linenumber" name="193" href="#193">193</a> <em class="jxr_javadoccomment">     * &lt;code&gt;Content-Type&lt;/code&gt; value.</em>
<a class="jxr_linenumber" name="194" href="#194">194</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="195" href="#195">195</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> parse(
<a class="jxr_linenumber" name="196" href="#196">196</a>             <strong class="jxr_keyword">final</strong> String s) <strong class="jxr_keyword">throws</strong> ParseException, UnsupportedCharsetException {
<a class="jxr_linenumber" name="197" href="#197">197</a>         Args.notNull(s, <span class="jxr_string">"Content type"</span>);
<a class="jxr_linenumber" name="198" href="#198">198</a>         <a href="../../../../org/apache/http/HeaderElement.html">HeaderElement</a>[] elements = BasicHeaderValueParser.parseElements(s, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="199" href="#199">199</a>         <strong class="jxr_keyword">if</strong> (elements.length &gt; 0) {
<a class="jxr_linenumber" name="200" href="#200">200</a>             <strong class="jxr_keyword">return</strong> create(elements[0]);
<a class="jxr_linenumber" name="201" href="#201">201</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="202" href="#202">202</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../org/apache/http/ParseException.html">ParseException</a>(<span class="jxr_string">"Invalid content type: "</span> + s);
<a class="jxr_linenumber" name="203" href="#203">203</a>         }
<a class="jxr_linenumber" name="204" href="#204">204</a>     }
<a class="jxr_linenumber" name="205" href="#205">205</a> 
<a class="jxr_linenumber" name="206" href="#206">206</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="207" href="#207">207</a> <em class="jxr_javadoccomment">     * Extracts &lt;code&gt;Content-Type&lt;/code&gt; value from {@link HttpEntity} exactly as</em>
<a class="jxr_linenumber" name="208" href="#208">208</a> <em class="jxr_javadoccomment">     * specified by the &lt;code&gt;Content-Type&lt;/code&gt; header of the entity. Returns &lt;code&gt;null&lt;/code&gt;</em>
<a class="jxr_linenumber" name="209" href="#209">209</a> <em class="jxr_javadoccomment">     * if not specified.</em>
<a class="jxr_linenumber" name="210" href="#210">210</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="211" href="#211">211</a> <em class="jxr_javadoccomment">     * @param entity HTTP entity</em>
<a class="jxr_linenumber" name="212" href="#212">212</a> <em class="jxr_javadoccomment">     * @return content type</em>
<a class="jxr_linenumber" name="213" href="#213">213</a> <em class="jxr_javadoccomment">     * @throws ParseException if the given text does not represent a valid</em>
<a class="jxr_linenumber" name="214" href="#214">214</a> <em class="jxr_javadoccomment">     * &lt;code&gt;Content-Type&lt;/code&gt; value.</em>
<a class="jxr_linenumber" name="215" href="#215">215</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="216" href="#216">216</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> get(
<a class="jxr_linenumber" name="217" href="#217">217</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpEntity.html">HttpEntity</a> entity) <strong class="jxr_keyword">throws</strong> ParseException, UnsupportedCharsetException {
<a class="jxr_linenumber" name="218" href="#218">218</a>         <strong class="jxr_keyword">if</strong> (entity == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="219" href="#219">219</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="220" href="#220">220</a>         }
<a class="jxr_linenumber" name="221" href="#221">221</a>         <a href="../../../../org/apache/http/Header.html">Header</a> header = entity.getContentType();
<a class="jxr_linenumber" name="222" href="#222">222</a>         <strong class="jxr_keyword">if</strong> (header != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="223" href="#223">223</a>             <a href="../../../../org/apache/http/HeaderElement.html">HeaderElement</a>[] elements = header.getElements();
<a class="jxr_linenumber" name="224" href="#224">224</a>             <strong class="jxr_keyword">if</strong> (elements.length &gt; 0) {
<a class="jxr_linenumber" name="225" href="#225">225</a>                 <strong class="jxr_keyword">return</strong> create(elements[0]);
<a class="jxr_linenumber" name="226" href="#226">226</a>             }
<a class="jxr_linenumber" name="227" href="#227">227</a>         }
<a class="jxr_linenumber" name="228" href="#228">228</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="229" href="#229">229</a>     }
<a class="jxr_linenumber" name="230" href="#230">230</a> 
<a class="jxr_linenumber" name="231" href="#231">231</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="232" href="#232">232</a> <em class="jxr_javadoccomment">     * Extracts &lt;code&gt;Content-Type&lt;/code&gt; value from {@link HttpEntity} or returns default value</em>
<a class="jxr_linenumber" name="233" href="#233">233</a> <em class="jxr_javadoccomment">     * if not explicitly specified.</em>
<a class="jxr_linenumber" name="234" href="#234">234</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="235" href="#235">235</a> <em class="jxr_javadoccomment">     * @param entity HTTP entity</em>
<a class="jxr_linenumber" name="236" href="#236">236</a> <em class="jxr_javadoccomment">     * @return content type</em>
<a class="jxr_linenumber" name="237" href="#237">237</a> <em class="jxr_javadoccomment">     * @throws ParseException if the given text does not represent a valid</em>
<a class="jxr_linenumber" name="238" href="#238">238</a> <em class="jxr_javadoccomment">     * &lt;code&gt;Content-Type&lt;/code&gt; value.</em>
<a class="jxr_linenumber" name="239" href="#239">239</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="240" href="#240">240</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> getOrDefault(
<a class="jxr_linenumber" name="241" href="#241">241</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpEntity.html">HttpEntity</a> entity) <strong class="jxr_keyword">throws</strong> ParseException, UnsupportedCharsetException {
<a class="jxr_linenumber" name="242" href="#242">242</a>         <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> contentType = get(entity);
<a class="jxr_linenumber" name="243" href="#243">243</a>         <strong class="jxr_keyword">return</strong> contentType != <strong class="jxr_keyword">null</strong> ? contentType : DEFAULT_TEXT;
<a class="jxr_linenumber" name="244" href="#244">244</a>     }
<a class="jxr_linenumber" name="245" href="#245">245</a> 
<a class="jxr_linenumber" name="246" href="#246">246</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="247" href="#247">247</a> <em class="jxr_javadoccomment">     * Creates a new instance with this MIME type and the given Charset.</em>
<a class="jxr_linenumber" name="248" href="#248">248</a> <em class="jxr_javadoccomment">     * </em>
<a class="jxr_linenumber" name="249" href="#249">249</a> <em class="jxr_javadoccomment">     * @param charset</em>
<a class="jxr_linenumber" name="250" href="#250">250</a> <em class="jxr_javadoccomment">     * @return a new instance with this MIME type and the given Charset.</em>
<a class="jxr_linenumber" name="251" href="#251">251</a> <em class="jxr_javadoccomment">     * @since 4.3</em>
<a class="jxr_linenumber" name="252" href="#252">252</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="253" href="#253">253</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> withCharset(Charset charset) {
<a class="jxr_linenumber" name="254" href="#254">254</a>         <strong class="jxr_keyword">return</strong> create(<strong class="jxr_keyword">this</strong>.getMimeType(), charset);
<a class="jxr_linenumber" name="255" href="#255">255</a>     }
<a class="jxr_linenumber" name="256" href="#256">256</a> 
<a class="jxr_linenumber" name="257" href="#257">257</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="258" href="#258">258</a> <em class="jxr_javadoccomment">     * Creates a new instance with this MIME type and the given Charset name.</em>
<a class="jxr_linenumber" name="259" href="#259">259</a> <em class="jxr_javadoccomment">     * </em>
<a class="jxr_linenumber" name="260" href="#260">260</a> <em class="jxr_javadoccomment">     * @param charset name</em>
<a class="jxr_linenumber" name="261" href="#261">261</a> <em class="jxr_javadoccomment">     * @return a new instance with this MIME type and the given Charset name.</em>
<a class="jxr_linenumber" name="262" href="#262">262</a> <em class="jxr_javadoccomment">     * @since 4.3</em>
<a class="jxr_linenumber" name="263" href="#263">263</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="264" href="#264">264</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/entity/ContentType.html">ContentType</a> withCharset(String charset) {
<a class="jxr_linenumber" name="265" href="#265">265</a>         <strong class="jxr_keyword">return</strong> create(<strong class="jxr_keyword">this</strong>.getMimeType(), charset);
<a class="jxr_linenumber" name="266" href="#266">266</a>     }
<a class="jxr_linenumber" name="267" href="#267">267</a> 
<a class="jxr_linenumber" name="268" href="#268">268</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

